// MonitorTest.cpp:     .
//

#include "stdafx.h"
#include "MonitorTest.h"

#define MAX_LOADSTRING 100

//  :
HINSTANCE hInst;								//  
TCHAR szTitle[MAX_LOADSTRING];					//   
TCHAR szWindowClass[MAX_LOADSTRING];			//    

//   ,     :
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(_In_ HINSTANCE hInstance,
                     _In_opt_ HINSTANCE hPrevInstance,
                     _In_ LPTSTR    lpCmdLine,
                     _In_ int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO:   .
	MSG msg;
	HACCEL hAccelTable;

	//   
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_MONITORTEST, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	//   :
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_MONITORTEST));

	//   :
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  : MyRegisterClass()
//
//  :   .
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MONITORTEST));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_MONITORTEST);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   : InitInstance(HINSTANCE, int)
//
//   :       .
//
//   :
//
//                ,  
//               .
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; //      

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  : WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  :      .
//
//  WM_COMMAND	-   
//  WM_PAINT	-  
//  WM_DESTROY	 -      .
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	static int W, H;
	static int C = 0;
	HPEN Pen, OldPen;

	switch (message)
	{
	case WM_SIZE:
		 W=LOWORD(lParam);
		 H=HIWORD(lParam);
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		//    :
		switch (wmId)
		{
		case ID_COLOR_RED:
			 C=2; InvalidateRect(hWnd,NULL,false);
			 break;
		case ID_COLOR_GREEN:
			 C=1; InvalidateRect(hWnd,NULL,false);
			break;
		case ID_COLOR_BLUE:
			 C=0; InvalidateRect(hWnd,NULL,false);
			break;
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		for (int i=0; i<H; i++)
		{
			switch(C)
			{
			case 0: Pen=CreatePen(PS_SOLID,1,RGB(0,0,i*255/(H-1))); break;
			case 1: Pen=CreatePen(PS_SOLID,1,RGB(0,i*255/(H-1),0)); break;
			case 2: Pen=CreatePen(PS_SOLID,1,RGB(i*255/(H-1),0,0)); break;
			}
			OldPen=(HPEN)SelectObject(hdc,Pen);
			MoveToEx(hdc,0,i,NULL); LineTo(hdc,W-1,i);
			SelectObject(hdc,OldPen);
			DeleteObject(Pen);
		}
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

//     " ".
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
